# Coveo CardOverlay Component (CoveoCardOverlay)

The CardOverlay component displays a button that the user can click to toggle the visibility of an overlay on top of an IQueryResult. While this component typically populates a CardActionBar component, it is actually possible to place a CardOverlay component anywhere in any result.

The primary purpose of the CardOverlay component is to display additional information about a result in a format that fits well within a card result layout (see Result Layouts).

When initialized, this component creates a `<div class="coveo-card-overlay">` element as the last child of its parent IQueryResult, and displays a button which toggles the visibility of the overlay.

## Index

### Methods

- closeOverlay
- debugInfo
- disable
- enable
- getBindings
- openOverlay
- toggleOverlay
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- icon
- title

### Constructors

- constructor

## Methods

### closeOverlay

- closeOverlay(): void

- - Defined in ui/CardOverlay/CardOverlay.ts :120

  Closes the CardOverlay.

  Also triggers the CardOverlayEvents.closeCardOverlay event.

  #### Returns void

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### openOverlay

- openOverlay(): void

- - Defined in ui/CardOverlay/CardOverlay.ts :108

  Opens the CardOverlay.

  Also triggers the CardOverlayEvents.openCardOverlay event.

  #### Returns void

### toggleOverlay

- toggleOverlay(swtch?: boolean): void

- - Defined in ui/CardOverlay/CardOverlay.ts :91

  Toggles the CardOverlay visibility.

  #### Parameters

  - ##### Optional swtch: boolean

    Specifying a value for this parameter forces the component visibility to take the corresponding value (`true` for visible; `false` for hidden).

  #### Returns void

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### icon

icon: string

- Defined in ui/CardOverlay/CardOverlay.ts :63

Specifies the icon to use for the overlay icon and for the button icon.

The name of the icon to use should be specified in dashed case. ie: facet-expand

Markup configuration example(s) :

    data-icon='foo'

### title

title: string

- Defined in ui/CardOverlay/CardOverlay.ts :53

Specifies the string to use for the overlay title and for the button text.

Setting a value for this option is required for this component to work.

Required

  Specifying a value for this option is required for the component to work

Markup configuration example(s) :

    data-title='foo'

## Constructors

### constructor

- new CardOverlay(element: HTMLElement, options?: ICardOverlayOptions, bindings?: IComponentBindings): CardOverlay

- Overwrites Component.constructor

  - Defined in ui/CardOverlay/CardOverlay.ts :64

  Creates a new CardOverlay component.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### Optional options: ICardOverlayOptions

    The options for the CardOverlay component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  #### Returns CardOverlay